# -*- coding: utf-8 -*-
"""
Created on Tue Mar 29 23:00:36 2022

@author: s3340992
"""
import math
from node import node

class vehicle:
    def __init__(self, number, manufacturer, pos_x, pos_y, battery_state, theta, last_node_id):
        self.number = number
        self.manufacturer = manufacturer
        self.pos_x = pos_x/100
        self.pos_y = pos_y/100
        self.battery_state = battery_state
        self.theta = theta
        self.last_node_id =last_node_id
        self.last_msg_time = 0
        self.send_msg = False
    
    def update_pos(self, pos_x, pos_y, time, node_list):
        self.last_pos_x = self.pos_x
        self.last_pos_y = self.pos_y
        self.pos_x = pos_x/100
        self.pos_y = pos_y/100
        #self.theta = math.pi/2
        if ((self.pos_x - self.last_pos_x)>=0):
            self.theta = math.atan((self.pos_y-self.last_pos_y)/(self.pos_x-self.last_pos_x))
        else:
            self.theta = math.atan((self.pos_y-self.last_pos_y)/(self.pos_x-self.last_pos_x))+math.pi
		
        self.last_update_time = time
        #print(time)
        if ((time-self.last_msg_time) >= 1):
            self.send_msg = True
        for i in range(len(node_list)):
            if (node_list[i].on_node(self.pos_x,self.pos_y)):
                self.send_msg = True